Package: RSEIS
Type: Package
Title: Seismic Time Series Analysis Tools
Version: 4.2-4
Date: 2024-09-12
Depends: R (>= 3.0)
Imports: RPMG, Rwave, stats
Suggests: GEOmap
Authors@R: c(person(given="Jonathan M.", family="Lees",
	   role = c("aut", "cre"),email = "jonathan.lees@unc.edu"),
	   	person(given="Jake", family="Anderson", role = "ctb", email = "ajakef@gmail.com"),
			       person(given='Leonard', family='Lisapaly', role = "ctb", email = "leonardl@fisika.ui.ac.id"),
			       person(given='Dave', family='Harris', role=c('aut', 'cph') ) )
Author: Jonathan M. Lees [aut, cre],
  Jake Anderson [ctb],
  Leonard Lisapaly [ctb],
  Dave Harris [aut, cph]
Maintainer: Jonathan M. Lees <jonathan.lees@unc.edu>
Description: Multiple interactive codes to view and analyze seismic data, via spectrum analysis, wavelet transforms, particle motion, hodograms.  Includes general time-series tools, plotting, filtering, interactive display.
License: GPL (>= 2)
Copyright: see inst/COPYRIGHTS
Packaged: 2024-09-12 18:55:00 UTC; lees
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2024-09-12 22:10:28 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 11:34:15 UTC; unix
Archs: RSEIS.so.dSYM

# Export all names
exportPattern(".")
useDynLib(RSEIS)
import(RPMG)
importFrom(Rwave , cwt)
importFrom(Rwave ,crc)
importFrom(Rwave ,cfamily)
importFrom("grDevices", "boxplot.stats", "dev.cur", "dev.list",
             "dev.new", "dev.next", "dev.off", "dev.set", "gray", "grey",
             "hsv", "postscript", "rainbow", "rgb", "terrain.colors",
             "topo.colors")
importFrom("graphics", "abline", "arrows", "axis", "box", "contour",
             "grid", "image", "image.default", "legend", "lines",
             "locator", "mtext", "par", "plot", "points", "polygon",
             "rect", "segments", "strheight", "strwidth", "text",
             "title", "xinch", "yinch")
importFrom("stats", "ccf", "coef", "convolve", "deltat", "dt", "embed",
             "fft", "is.ts", "lm", "median", "mvfft", "plot.ts", "qf",
             "quantile", "runif", "runmed", "smooth.spline", "spline",
             "ts", "var", "rnorm", "approx", "sd")
importFrom("utils", "write.table")

#######  read in data sunspot  and plot
######  using swig
options(demo.ask=FALSE)

data(sunspots)

###  prepare the time series for input to RSEIS

####  step 1:  This puts it into the format used by Rsac
ES = prep1wig(wig=sunspots, dt=1/12, sta="STA", comp="CMP", units="UNITS"    )

####  this puts it into the format used by RSEIS:
####  step 2:
EH=prepSEIS(ES)


########  pop up the signals using swig
STDLAB = c("DONE",  "zoom in", "zoom out", "refresh", "restore",
 "XTR", "SPEC", "SGRAM" ,"WLET", "FILT",  "Pinfo")
######## 
######## 
######## 
######## swig is a generic Picking program
######## Use left Mouse click to select traces and windows.
######## Use the buttons to operate on the selected traces/windows
########  To zoom, click twice with the left mouse on the traces, then right mouse zooms
########  Right Mouse with no left mouse clicks is equivalent to "Done"
######## 

xx =  swig( EH, STDLAB = STDLAB)

#########  get some data 
data(KH)


##### informaiton on the data structure:
names(KH)

#####  seismic wiggles are in JSTR


dt = KH$dt[1]

y =  KH$JSTR[[1]]

x =  seq(from=0, by=dt, length=length(y))

##########  plot the data:
plot(x,y, type='l', xlab='s', ylab='amp', main="Vertical Comp Seismic Volcano Explosion")

readline("To Continue Hit Enter Key\n")


################    filter the data

#######  use a band pass, butterworth filter from 10 s to 1 Hz

fy = butfilt(y, .1, 1, dt, "BP", "BU" )


plot(x,fy, type='l', xlab='s', ylab='amp', main="Bandpass filter  10 s to 1 Hz" )

readline("To Continue Hit Enter Key\n")

################ make a plot of both traces on the same figure:
PLOT.MATN(cbind(y, fy), tim=x, dt=dt , notes=c("raw", "filtered" ) , COL=c('brown', 'blue'))

readline("To Continue Hit Enter Key\n")


################ zoom in on part of the plot
## could use locator here as in win=locator(2); win=win$x

win =c(100, 200)


PLOT.MATN(cbind(y, fy), tim=x, dt=dt , WIN=win, notes=c("raw", "filtered" ) , COL=c('brown', 'blue'))

readline("To Continue Hit Enter Key\n")


##############################################
########   repeat  filtering example with pre and post-tapering
###  remove mean of data
By = y  - mean(y)
####
#### taper the data
By = applytaper(By, p=0.05)
flow =1/100
fhi = 1
fy = butfilt(By, flow, fhi, dt, "BP", "BU" )
fy = applytaper(fy, p=0.05)

flab =paste(sep=" ", "BP filtered:", flow, "to", fhi, "Hz" )

  
PLOT.MATN(cbind(y, fy), tim=x, dt=dt , notes=c("raw", flab) , COL=c('brown', 'blue'))


readline("To Continue Hit Enter Key\n")

##############################################
##############################################   suite of filters:
##############################################

###  set up filters:
fl=rep(1/100, 5)
fh=1/c(1,2,5,10,20)



###  show a filter spread using the above definition:

FILT.spread(x, y, dt, fl = fl, fh = fh, sfact = 1, WIN = NULL, PLOT = TRUE, TIT = NULL, TAPER = 0.05, POSTTAPER=0.1)


readline("To Continue Hit Enter Key\n")


###  zoom in on filter spread
FILT.spread(x, y, dt, fl = fl, fh = fh, sfact = 1, WIN = win, PLOT = TRUE, TIT = NULL, TAPER = 0.05)


readline("To Continue Hit Enter Key\n")


##############################################

### R code from vignette source 'hodo.Rnw'

###################################################
### code chunk number 1: hodo.Rnw:66-67
###################################################
library(RSEIS)


###################################################
### code chunk number 2: hodo.Rnw:74-78
###################################################
data(GH)

swig(GH, SHOWONLY=TRUE)



###################################################
### code chunk number 3: hodo.Rnw:84-85
###################################################
print(GH$pickfile$STAS$name)


###################################################
### code chunk number 4: hodo.Rnw:91-101
###################################################

thesta = "CE1"
iwv  = which(GH$STNS==thesta & GH$COMPS=="V")
iwn  = which(GH$STNS==thesta & GH$COMPS=="N")
iwe  = which(GH$STNS==thesta & GH$COMPS=="E")


data = cbind(GH$JSTR[[iwv]], GH$JSTR[[iwn]], GH$JSTR[[iwe]])




###################################################
### code chunk number 5: hodo.Rnw:109-118
###################################################
ipphase = which(GH$pickfile$STAS$name==thesta & GH$pickfile$STAS$phase=="P" )
isphase = which(GH$pickfile$STAS$name==thesta & GH$pickfile$STAS$phase=="S" )


lat=GH$pickfile$STAS$lat[ipphase]
lon = GH$pickfile$STAS$lon[ipphase]
DAZ = rdistaz(lat, lon,   GH$pickfile$LOC$lat,GH$pickfile$LOC$lon )
 rbaz = grotseis(DAZ$baz, flip=FALSE)



###################################################
### code chunk number 6: hodo.Rnw:124-134
###################################################

plot( c(GH$pickfile$STAS$lon, GH$pickfile$LOC$lon) , c(GH$pickfile$STAS$lat, GH$pickfile$LOC$lat), type='n', xlab="LON", ylab="LAT")
points(GH$pickfile$STAS$lon, GH$pickfile$STAS$lat, pch=6)
points(GH$pickfile$LOC$lon, GH$pickfile$LOC$lat, pch=8)
text(GH$pickfile$STAS$lon, GH$pickfile$STAS$lat,  GH$pickfile$STAS$name, pos=3)

##  plot( c(lon, GH$pickfile$LOC$lon) , c(GH$pickfile$STAS$lat, GH$pickfile$LOC$lat))
##  text(lon, lat, labels="station")




###################################################
### code chunk number 7: hodo.Rnw:144-164
###################################################

x = DAZ$dist*sin(DAZ$baz*pi/180)
y = DAZ$dist*cos(DAZ$baz*pi/180)

plot(c(0,1.3*x), c(0,1.3*y), type='n', asp=1, xlab="E-W, km", ylab="N-S, km")
points(c(0,x), c(0,y), pch=c(3,6))
text(x,y, labels="station", pos=1)
text(x,y, labels=GH$pickfile$STAS$name[ipphase], pos=2)


text(0,0, labels="source", pos=3)

vecs  = rbind(c(0,0,1), c(0,1,0))
bvec  = vecs %*%  rbaz

bvec = .1*DAZ$dist*bvec
arrows(x,y, x+bvec[,2], y+bvec[,3], col=c("red", "blue"))

 



###################################################
### code chunk number 8: hodo.Rnw:170-181
###################################################

## data = cbind(GH$JSTR[[iwv]], GH$JSTR[[iwn]], GH$JSTR[[iwe]])

  vnelabs=c("Vertical", "North", "East")
  
rotlabs=c("Vertical", "Radial(away)", "Transvers(right)")

 xt=seq(from=0, by=GH$dt[iwv], length=length(GH$JSTR[[iwv]]))

 PLOT.MATN(data, tim=xt, dt=GH$dt[iwv], notes=vnelabs)



###################################################
### code chunk number 9: hodo.Rnw:189-195
###################################################

## data = cbind(GH$JSTR[[iwv]], GH$JSTR[[iwn]], GH$JSTR[[iwe]])
btemp  = data  %*%  rbaz

 PLOT.MATN(btemp, tim=xt, dt=GH$dt[iwv], notes=rotlabs)



###################################################
### code chunk number 10: hodo.Rnw:205-234
###################################################


i1 = match(GH$STNS[iwv],  GH$pickfile$STAS$name)


reft = list(jd=GH$info$jd[iwv], hr=GH$info$hr[iwv], mi=GH$info$mi[iwv], sec=GH$info$sec[iwv] )


ptim = list(jd=GH$pickfile$LOC$jd, hr=GH$pickfile$LOC$hr, mi=GH$pickfile$LOC$mi, sec=GH$pickfile$STAS$sec[ipphase] )
stim = list(jd=GH$pickfile$LOC$jd, hr=GH$pickfile$LOC$hr, mi=GH$pickfile$LOC$mi, sec=GH$pickfile$STAS$sec[isphase] )

t1 = secdifL( reft, ptim)
t2 = secdifL( reft, stim)

 PLOT.MATN(btemp, WIN=c(5,8) , tim=xt, dt=GH$dt[iwv], notes=rotlabs)
abline(v=t1, col='red', lty=2)
abline(v=t2, col='blue', lty=2)

mtext(side=3, at=t1, line=.1, text="Pwave", col='red')
mtext(side=3, at=t2, line=.1, text="Swave", col='blue')

pwin = c(t1-.02, t1+.09)
swin = c(t2-.01, t2+.1)

abline(v=pwin, col='red', lty=2)
abline(v=swin, col='blue', lty=2)





###################################################
### code chunk number 11: hodo.Rnw:240-247
###################################################
rbow=rainbow(140)[1:100]

atemp = btemp[xt>pwin[1]&xt<pwin[2]  ,]
##  PLOT.MATN(atemp,  tim=xt[xt>pwin[1]&xt<pwin[2]], dt=GH$dt[iwv], notes=rotlabs)

 hodogram(atemp, dt=GH$dt[iwv]  ,labs=rotlabs,  STAMP=thesta,  COL=rbow )



###################################################
### code chunk number 12: hodo.Rnw:252-258
###################################################

atemp = btemp[xt>swin[1]&xt<swin[2]  ,]
###  PLOT.MATN(atemp,  tim=xt[xt>swin[1]&xt<swin[2]], dt=GH$dt[iwv], notes=rotlabs)

 hodogram(atemp, dt=GH$dt[iwv]  ,labs=rotlabs,  STAMP=thesta,  COL=rbow )

###############  reproduce the figures, more or less from Lees and Park, 1995

require(RSEIS)
##############  Slepian Tapers:
 nwin = 5
     npi = 3
     npoints = 900
     sleps = get.slepians(npoints, nwin, npi)

     matplot(sleps, type='l', xlab="Index", ylab="Taper Amplitude")
     legend('topleft', legend=1:nwin, lty=1:nwin, col=1:nwin)
title("Slepian Tapers: Figure 1, Lees and Park, 1995")
readline("To Continue Hit Enter Key\n")
##############
##############  EXAMPLES:



f1 =20
f2 = 30
dt = 0.01

t = seq(from=0, to=6, by=dt)


noise =  runif(length(t), 0, 2)

y = 2*sin(2*pi*f1*t) + 3*sin(2*pi*f2*t) + noise 

par(mfrow=c(1,1))
plot(t,y, type='l')

title("Figure 2(synthetic example 1): Lees and Park, 1995")


readline("To Continue Hit Enter Key\n")
###############
##########################  make a function to get the single taper spectrum

singleTaper<-function(y, dt, tappercent=0.1 )
  {
    if(missing(tappercent)) tappercent=0.1
    N= length(y)	
    fn = 1/(2*dt)
    tapy = rsspec.taper(y, p=tappercent)
    ##tapy = tapy-mean(tapy)
    
    Y = fft(tapy)
    Pyy = (Mod(Y)^2)/(N*N)
    ##  Pyy = Y * Conj(Y)
    n = floor(length(Pyy)/2)
    Syy = Pyy[1:n]
    f = (0:(length(Syy)-1))*fn/length(Syy)
#####    plot(f, Syy, type='l', xlab="frequency", ylab="Power Density", log='')
    
    invisible(list(f=f, syy=Syy))
    
  }
#######################  make a function to create the plots
DOLEESPARK<-function(y, dt, tappercent=0.1)
  {

    y = y-mean(y)

####

    nn=next2(length(y))

    Mspec =   mtapspec(y, dt, klen=nn,  MTP=list(kind=2,nwin=5, npi=3,inorm=1)  )
    f = Mspec$freq

    amp1 = Mspec$spec[1:length(f)]
    amp = 10*log10(amp1 )

#### 
    singy = singleTaper(y, dt, tappercent=tappercent)
    
    stap1 = 10*log10(singy$syy )

#### 
    squig = list(y=y, dt=dt)
    ZIM = autoreg(squig , numf=length(Mspec$freq) , pord = 80, PLOT=FALSE)

    AutoR = 10*log10(ZIM$amp )

#### 
    frange = range(c( f ))
    amprange  = range(c(amp, stap1, AutoR))

####
   ## dev.new()

    
    opar <- par(no.readonly = TRUE)

    par(mfrow=c(3,1))
    
    plot(frange, amprange, type='n',ylab="Spectrum Amplitude", xlab="Frequency")


     kdof = 2*Mspec$mtm$nwin-2
    ppoints  =  c(50.0, 90.0, 95.0, 99.0, 99.5, 99.9)
    myf = qf(ppoints/100, 2, kdof)

    hivals1 = Mspec$freq[which(Mspec$Fv[1:length(Mspec$freq)]>myf[3] & Mspec$dof[1:length(Mspec$freq)]>9.0  )]
    hivals2 = Mspec$freq[which(Mspec$Fv[1:length(Mspec$freq)]>myf[4] & Mspec$dof[1:length(Mspec$freq)]>9.0  )]

    lightgreen = rgb(.8,1,.8)
    darkgreen  = rgb(.1, .8, .1)

    
    abline(v=hivals1, col=lightgreen , lty=2)
    abline(v=hivals2, col=darkgreen, lty=2)

    
    lines(f, amp)

    lines(ZIM$freq,AutoR, col='red')
    lines(singy$f,stap1, col='blue')
#### 
    title("Lees and Park, 1995")
    legend("topright", legend=c("multitaper",  "Autoregressive", "Single-taper"), lty=c(1,1,1), col=c("black", "red", "blue"))

###   show diagnostics from MTM estimate:



    plot(Mspec$freq,Mspec$dof[1:length(Mspec$freq)],type='l',xlab="Frequency",ylab="Effective Degrees of Freedom")
      abline(v=hivals1, col=lightgreen, lty=2)
     abline(v=hivals2, col=darkgreen, lty=2)

    plot(Mspec$freq, Mspec$Fv[1:length(Mspec$freq)],type='l',xlab="Frequency",ylab="F-test")
    abline(v=hivals1, col=lightgreen, lty=2)
     abline(v=hivals2, col=darkgreen, lty=2)

    u=par("usr")
#####  see Percival and Walden p. 499-500 for degrees of freedom
   
    abline(h=myf,lty=2 )
    text(u[2],myf,ppoints, pos=4, xpd=TRUE)

    par(opar)
  }

###############  show various spectrum estimates


DOLEESPARK(y, dt, tappercent=0.05)

readline("To Continue Hit Enter Key\n")

###############   next example shows 1000
###   traces aded together each with the same amplitude spectrum, shifted by a linear phase
###  equivalent to one sample.

dt = 1
cut =  0.125
NF = 1024*8
ff = seq(from=0, to=1, length=NF)

mf = rep(1, NF)
mf[ff>0.125&ff<=0.875] = 0

K = (NF/2)

j = K/2
phz1 = 2*pi*j*ff
FIL = runif(1)* mf * as.complex(cos(phz1), sin(phz1) )

G = FIL
ag = fft(G, inverse = TRUE) / (NF/2)
y = Re(ag)[1:(NF/2)]

####  plot(seq(from=0, length=(NF/2), by=1), y, type='l', xlab='time', ylab="amplitude")

####  readline("To Continue Hit Enter Key\n")
v=NF/4

N = 1000
MY = rep(0, N)
for(i in (v-1000):(v) )
{
  i1 = i
  i2 =  i1+N-1
 #### print(paste(i1,i2, length(i1:i2) ))
  MY =   MY+runif(1)*y[i1:i2]
}

MY = MY/N
MY = detrend(MY)

plot(seq(from=0, length=length(MY), by=1), MY, type='l', xlab='time', ylab="amplitude")
title("Input Signal 2")



readline("To Continue Hit Enter Key\n")




dt2=1
DOLEESPARK(MY, dt2, tappercent=0.05)
readline("To Continue Hit Enter Key\n")
#######################
########  apply same method to the Delta-O18 data
data(OH)

plot( seq(from=0, length=length(OH$JSTR[[1]]), by=3000), OH$JSTR[[1]], type='l', xlab="time, yrs", ylab="Delta O18")
title("Delta O18")

readline("To Continue Hit Enter Key\n")


DOLEESPARK(OH$JSTR[[1]], 3, tappercent=0.05)

###title("Delta-O18")


readline("DONE: To Continue Hit Enter Key\n")

#######  read in data  from Reventador Volcano, Ecuador, and plot
######  using PICK.GEN
options(demo.ask=FALSE)

data(KH)
STDLAB = c("DONE",  "zoom in", "zoom out", "refresh", "restore",
 "XTR", "SPEC", "SGRAM" ,"WLET", "FILT",  "Pinfo")

######## swig is a generic Picking program
######## Use left Mouse click to select traces and windows.
######## Use the buttons to operate on the selected traces/windows
########  To zoom, click twice with the left mouse on the traces, then right mouse zooms
########  Right Mouse with no left mouse clicks is equivalent to "Done"

xx =  swig( KH, sel=which(KH$COMPS == "V"), STDLAB = STDLAB)

require(RSEIS)


data(KH)


##### informaiton on the data structure:
names(KH)

#####  seismic wiggles are in JSTR


dt = KH$dt[1]

y =  KH$JSTR[[1]]

tim =  seq(from=0, by=dt, length=length(y))

##########  plot the data:
plot(tim, y, type='l', xlab='s', ylab='amp', main="Volcano Explosion")

readline("To Continue Hit Enter Key\n")

y = y[tim>=82 & tim<=195]
x = tim[tim>=82 & tim<=195]
plot(x,y, type='l', xlab='s', ylab='amp')

y = y-mean(y)

readline("To Continue Hit Enter Key\n")

###############
len  = length(y)
len2 = 2*next2(len)

Mspec =   mtapspec(y,dt, klen=len2,  MTP=list(kind=1,nwin=5, npi=3,inorm=0)  )

f1 = 0.01
f2 = 10
f = Mspec$freq
    amp = Mspec$spec[1:length(f)]
    
    flag = f >= f1 & f <= f2
  displ = amp
###############  plot data
plot((f[flag]), (displ[flag]), type = "l",
            log = "", axes = TRUE, xlab = "Hz", ylab = "Spec")


readline("To Continue Hit Enter Key\n")

###############  plot data with LOG=LOG
plot((f[flag]), (displ[flag]), type = "l",
            log = "xy", axes = TRUE, xlab = "Hz", ylab = "Spec")


readline("To Continue Hit Enter Key\n")

###############  plot data with DB scale

db1  = 20*log10(displ[flag]/max(displ[flag]) ) 
plot((f[flag]),  db1   , type = "l",
            log = "", axes = TRUE, xlab = "Hz", ylab = "Db")


readline("To Continue Hit Enter Key\n")

############  compare different kinds of power spectra

   data(OH)
    
y=OH$JSTR[[1]]
dt = OH$dt
    
fn = 1/(2*dt)    
t = seq(0, by=3000, length=length(y))
plot(t, y, type='l', main="Oxygen Isotope: Delta O-18", xlab="time, years")

y = y-mean(y)
    
z = applytaper(y , p=.05)

plot(t,z, type='l', main="Oxygen Isotope: Delta O-18", xlab="time, years")
readline("To Continue Hit Enter Key\n")


    Z = fft(z)
    Zyy = Z * Conj(Z)
    n = length(Zyy)/2
    Syy = Mod(Zyy[1:n])/length(z)

Syy = 20*log10(Syy/max(Syy))
 fyy = (0:(length(Syy)-1))*fn/length(Syy)


Mspec =   mtapspec(z,dt, klen=len2,  MTP=list(kind=1,nwin=5, npi=3,inorm=0)  )

    f1 = 0.01
f2 = 10
f = Mspec$freq
    amp = Mspec$spec[1:length(f)]
    
    flag = f >= f1 & f <= f2
  
###############  plot data

 dbamp = 20*log10(amp/max(amp))


prange = range(c( dbamp[flag], Syy[fyy>= f1& fyy<= f2] ) )
frange = range( f[flag] )


plot(frange, prange, type = "n",
            log = "", axes = TRUE, xlab = "1/3000 yr", ylab = "Db")

lines(f[flag],dbamp[flag] , col='black')

lines(fyy, Syy, col='red')

title(main="Delta-O18 data with simple periodogram vs MTM method")

readline("To Continue Hit Enter Key\n")

  ###



####    use welch's method to determine power spectrum
  
    rwelch = setwelch(y, win=min(80,floor(length(y)/10)),
      inc=min(24, floor(length(y)/30)), coef=256, wintaper=0.2 )
    
    KK = apply(rwelch$values, 2, FUN="mean")
    
    wf=seq(from=0, to=0.5, length=256)*1/dt
    DbKK = 20*log10(KK/max(KK))
    

    lines(wf, DbKK, col='blue')


####
xx=c(96702.6,41220.7,23789.5,22362.2,19011.4) 

milank = c(100000, 41000,  22000)


abline(v=1/(milank/10000), lty=2, col=grey(.7) )

abline(v=1/(xx/10000), lty=2, col=rgb(.7, .3,.3) )




readline("To Continue Hit Enter Key\n")

######################################################
######  Interactive display of spectrum
######################################################

a = list(y=y, dt=dt)

######################################################
#########   click in figure for interaction:
######### when finished click "Done"
######################################################

MTM.drive(a, f1=.01, f2=10, len2=1024, COL=2, PLOT=TRUE, PADDLAB=NULL, GUI=TRUE)


readline("To Continue Hit Enter Key\n")


#####  repeat the above analysis with a different time series:

A = as.vector(sunspots)


dt = 1/12

X =  seq(from=0, by=dt, length=length(A))
plot(X,A, type='l', xlab='Yr', ylab='amp', main="Sunspots")

readline("To Continue Hit Enter Key\n")


#######  remove mean
A = A-mean(A)

len  = length(A)
len2 = 2*next2(len)


###  get MTM spectrum
Mspec =   mtapspec(A,dt, klen=len2,  MTP=list(kind=1,nwin=5, npi=3,inorm=0)  )

f1 = 0.01
f2 = 3
f = Mspec$freq
    amp = Mspec$spec[1:length(f)]
    
    flag = f >= f1 & f <= f2
  displ = amp
db1  = 20*log10(displ[flag]/max(displ[flag]) ) 
plot((f[flag]),  db1   , type = "l",
            log = "", axes = TRUE, xlab = "1/yr", ylab = "Db", main="Sunspot Spectrum")

abline(v=1/11, col='blue', lty=2)

mtext("11 year", side=3, at=1/11)

readline("To Continue Hit Enter Key\n")

print("End of SPECT demo")
#####################################
#####################################
#####################################

#######  read in data from the coso geothermal field and plot
######  using swig
options(demo.ask=FALSE)

data("GH")

######### 
####  
STDLAB = c("DONE",  "zoom in", "zoom out", "refresh", "restore",
 "XTR", "SPEC", "SGRAM" ,"3COMP", "FILT",  "Pinfo")

###sel = which(GH$COMPS=="V")

gsel = getvertsorder(GH$pickfile, GH)


###swig(GH, sel=sel,    STDLAB=STDLAB)


upix = uwpfile2ypx(GH$pickfile)


#########     Repeat, this time sort the traces, plot the archive picks with errors
#########      and
#########     select only a few buttons,
######### 

pickgeninfo()

#########  
swig(GH, sel=gsel$sel, APIX =upix,    STDLAB =STDLAB, WIN =c(4,13) )

\documentclass{article}
\usepackage{amsmath} %Never write a paper without using amsmath for its many new commands
\usepackage{amssymb} %Some extra symbols
\usepackage{makeidx} %If you want to generate an index, automatically
\usepackage{graphicx} %If you want to include postscript graphics
%%%  \usepackage{mystyle} 
%Create your own file, mystyle.sty where you put all your own \newcommand statements
%%%
%%%
\usepackage{amscd}

\usepackage{Sweave}


%%\VignetteIndexEntry{Examples from RSEIS}

%%% \usepackage{Sweave}

\begin{document}

%%%\renewcommand\floatpagefraction{.9}
%%%\renewcommand\topfraction{.9}
%%%\renewcommand\bottomfraction{.9}
%%%\renewcommand\textfraction{.1}
%%%\setcounter{totalnumber}{50}
%%%\setcounter{topnumber}{50}
%%%\setcounter{bottomnumber}{50}

\setkeys{Gin}{width=0.9\textwidth}



\numberwithin{equation}{section}

%%%   \SweaveOpts{prefix.string=rseis}
\SweaveOpts{prefix=TRUE,prefix.string=rseis,include=TRUE}


\author{Jonathan M. Lees\\
University of North Carolina, Chapel Hill\\
Department of Geological Sciences\\
CB \#3315, Mitchell Hall\\
Chapel Hill, NC  27599-3315\\
email: jonathan.lees@unc.edu\\
ph: (919) 962-0695
}
%%  \address{University of North Carolina, Chapel Hill}
%% \contact{Jonathan M. Lees}
%% \contactaddress{Department of Geological Sciences, CB #3315, Mitchell Hall, Chapel Hill, NC  27599-3315}
%% \contactemail{jonathan.lees@unc.edu}
%% \contactphone{(919) 962-0695}
\title{RSEIS: Seismic Time Series Analysis in R}
\date{\today}

\maketitle


\begin{abstract}
I present several new packages for analyzing seismic data for time
series analysis and earthquake focal mechanisms.  The packages
consists of modules that 1) read in seismic waveform data in various
common exchange formats, 2) display data as either event or continuous
recordings and 3) performs numerous standard analyses applied to
earthquake and volcano monitoring.  RSEIS is designed as a research
tool aimed at investigators who need to quickly assess large amounts
of time-series as they are related to the spatial distribution of
geologic structure and wave propagation.  In addition to time series
analysis, a spatial mapping program is included that ties waveforms
and radiation patterns to geographical data-base and mapping programs.
\end{abstract}


\section{Waveform Analysis}

The waveform module of RSEIS reads in seismic data in SEGY, SAC, AH,
UW and various ASCII formats.  The core of these modules are a set of
C programs that pass waveforms back to R and wrappers that create
lists of seismograms.  RSEIS was written primarily for use with
continuous data, so the R code is able to sort a large database
consisting of continuous data from several stations and numerous
components.  Each component of the waveform database may have a
different sample rate and may require very different handling in terms
of instrument de-convolution.  Time-windows provided by the user are
used to select off parts of the continuous data and rectify timing so
that all traces represent identical time slots.  Seismic data (binary
or ASCII format) are read into R and stored in structures that provide
a platform for object oriented manipulation of complex information
regarding earth dynamics.  In my case, I use this package to
investigate exploding volcanoes in Ecuador, Guatemala, Kamchatka and
Italy.

An initial, interactive display of the seismic records is presented to
the user and a large array of useful options are available for further
processing by buttons that surround the main display but are on the
same graphics device.  Some of the routines employed in the RSEIS
package are drawn from packages already available on the R
distribution, for example wavelet transforms - although these have
been modified to some extent to accommodate specific concerns of
seismologists. Other modules, like those dealing with focal mechanisms
and radiation patterns are original and will prove useful for
investigators searching for patterns of stress distribution in fault
regions.  


\section{Getting started}

Start by downloading packages and installing locally in the
machine being used.
The packages required by RSEIS include RPMG, and Rwave, 
and RFOC if focal mechanisms are going to be inspected.

<<fig=FALSE, echo=TRUE, results=hide>>=

library(RSEIS)
library(RPMG)

options(continue = " ")

@ 

\subsection{Example: Reventador Volcano Explosion }


There several data set that accompany RSEIS,
and these can be loaded with simple calls to data().
For example,
<<fig=FALSE, echo=TRUE, results=hide>>=
data(KH)
names(KH)

@ 
loads a structure that includes wave forms and other important
meta-data about the earthquake.  To see a view of this data
we call the main program and display the earthquake records as they are stored
in memory,

<<fig=FALSE, echo=FALSE, results=hide>>=

pdark=c("tomato3","royalblue","forestgreen","blueviolet","tan3",
"lightseagreen","deeppink","cyan3",
"bisque3","magenta1","lightsalmon3","darkcyan", "gold4" ,      
"darkorange1", "goldenrod4" , "seagreen3" ,  "lightpink3")

palette(pdark )


@ 

<<fig=TRUE, echo=TRUE, results=hide>>=


STDLAB = c("DONE",  "zoom in", "zoom out", "refresh", "restore",
 "XTR", "SPEC", "SGRAM" ,"WLET", "FILT",  "Pinfo")


swig(KH, SHOWONLY=FALSE, WIN = c(90, 200) , STDLAB=STDLAB)

@ 
In this example we are showing the vertical component of an explosion 
of Reventador Volcano.  The buttons at the top
are defaults chosen from a large selection of 
buttons designed to be useful for analyzing seismic data.
To zoom in on the trace, click twice on the trace with the left mouse button,
and then terminate by clicking the middle mouse.
(Clicking with the middle mouse with now left mouse clicks terminates the interactive session).
When your are finished with RSEIS windows click the ``Done'' 
button to close the window.  Avoid using the small
``x'' in the corner of the window to terminate because
R does not know you have finished yet.

You can view spectra of the signal (SPEC) , spectrograms (SGRAM) 
and wavelet transforms (WLET). To illustrate,
left click on this trace around t=1200 and t=2000, which 
windows the harmonic tremor part of this explosion.
Click middle mouse to zoom in, or
select one of the buttons at
the top to analyze the time series in the (selected) sub-window.
Choose  \emph{WLET} to show the wavelet transform of
the harmonic tremor and important time variations of the
volcano during eruption.

The swig program is normally run in interactive mode.
In that case, once it is started R is waiting for
the user to select traces and buttons for
activating a variety of programs and analysis 
routines.
Selection of traces is accomplished by clicking on the traces,
one or more times depending 
on what is desired.
The program needs to know what to do with the 
selections once that process is over, 
usually by clicking on a button around the perimeter 
of the screen.  In the next example we will restrict the analysis
to just the vertical motion seismic data, at least for now.
If you expand the screen, you can re-arrange the buttons by
clicking on the refresh button.

swig is a general analysis program designed for earthquake studies.
It uses the {\emph Really Poor Man's GUI} to 
navigate between seismic traces and 
various analysis procedures.
Once the program is started it waits for the user to
select on the screen a variety of operations, determined
by the user via the button selection, STDLAB.
In the main event loop, 
the user may click on the screen with the left mouse 
button to hi-light specific traces or windows in the panel.
The right mouse click terminates the clicking sequence and
a decision is made on what to do, unless a button has been clicked.
Generally, one click selects a specific trace,
two clicks specify a trace and window in that trace.
If the clicking is terminated immediately, 
before a left mouse is clicked, the program stops and returns
NULL.
If it terminates after 1 click, a refresh screen 
command is produced. If there are two or more clicks,
and no button is pressed, the last two clicks are
used to zoom in the window.

If a button is clicked, however, 
the program
uses the number of clicks to determine
which traces to process and what to do.
For example, if the ``PickWin'' button is selected,
a new swig is spawned where the program 
gathers all the components for that station, Usually Vertical, North and East,
although in the presence of acoustic channels they will also be displayed.
The new window is called with a new set of Buttons
set up specifically for picking the P, S and Acoustic arrivals.
Once that window is finished, focus reverts to the main 
window and the new picks are registered.
Selecting the ``SavePF'' button will save the
new picks to a file for later use.

As another example, if the user clicks twice in a trace panel,
and then selects the WLet Button, a wavelet transform
of the selected time window is calculated and 
a special new screen is exposed where the 
user is now focused until that session is finished by
clicking ``Done''.

Each Button has different properties based on the 
requirements for that process.  Some buttons 
expect more than one click to operate properly, others 
are simple buttons that control the look and feel of the 
panel. For example, the ``restore'' button
reverts the panel to its original time window.
It can be pressed any time and the 
window will redraw and resize.
Each button includes a small set of instructions
designed to accomplish a specific task.
There are many buttons currently defined, some described below, and 
there is mechanism for users to  make their own
on the fly.


\subsection{Example: Coso Geothermal Event }

<<fig=FALSE, echo=TRUE, results=hide>>=

data(GH)
numstas = length(GH$STNS)


@ 

In this example, taken from the geothermal field 
at Coso, California, there are \Sexpr{numstas} stations,
most of which have three components (Vertical, North and East),
although there are a couple of stations that are missing
some of the components.  This situation is not 
atypical of earthquake seismic data recorded in the field.
If we show only the vertical component traces,
The plot is more manageable and easier to view:
<<fig=TRUE, echo=TRUE, results=hide>>=


verts = which(GH$COMPS == "V")

STDLAB = c("DONE", "QUIT",  "NEXT","PREV",  "zoom in", "zoom out", "refresh", "restore", "SavePF", 
"PickWin", "XTR", "SPEC", "SGRAM" ,"WLET", "FILT", "Pinfo", "WINFO", "PTS", "YPIX", "WPIX")


swig(GH,  sel=verts[c(1,2,3,4,6) ] ,STDLAB =STDLAB, WIN=c(4,15),  SHOWONLY=TRUE)


@ 




We see that the stations here are 'mixed up', i.e. arriving at different times.
<<fig=TRUE, echo=TRUE, results=hide>>=

vertord = getvertsorder(GH$pickfile, GH)

swig(GH,  sel=vertord$sel[1:5] ,      STDLAB =STDLAB,  WIN=c(4, 15), SHOWONLY=FALSE)

@ 

A seismic event is usually stored as a combination
of waveform information and meta-date associated with
the phase arrivals.  Phase arrivals are
commonly called ``picks'' since and analyst 
had to pick the arrival times from a representation
of the seismic signals, either on a computer or on a paper
record.
The picks are stored in RSEIS 
in a list structure called pickfile
which is an optional  component of the name waveform structure.
The pickfile structure is a list comprising several
sub-lists with important information associated with
stations and the event (earthquake) source.
<<>>=
names(GH$pickfile)
@ 
For now we consider the most relevant 
meta-data, 
<<>>=
names(GH$pickfile$STAS)
@ 
which is a list of vectors, 
one for each meta-datum and one element
each for each station that has meta-data.
We see in this example there are a couple of picks per station,
some picks are on the vertical components and some
are on the North component or East, there
are P and S-wave phase picks.
<<>>=
data.frame(cbind(name=GH$pickfile$STAS$name, comp=GH$pickfile$STAS$comp, phase=GH$pickfile$STAS$phase, time=GH$pickfile$STAS$sec, lat=GH$pickfile$STAS$lat, lon=GH$pickfile$STAS$lon))
@ 
We also store event information:
<<>>=
names(GH$pickfile$LOC)
@ 

Using this information we can associate the 
p-pick with the waveforms, match the timing information
and plot together.
finally we add the picks to the section:
<<fig=TRUE, echo=TRUE, results=hide>>=

apx = uwpfile2ypx(GH$pickfile)
swig(GH,  sel=vertord$sel[1:5] , APIX=apx, STDLAB =STDLAB,  WIN=c(4, 15), SHOWONLY=FALSE, velfile=VELMOD1D, )


@ 

Brief documentation for buttons in the swig
program can be seen by calling the documentation function,
either for a specific button 

<<>>=
PICK.DOC('WLET')

@ 
or for 
all possible buttons.
<<>>=
PICK.DOC()

@ 


\subsection{Example: SunSpots}

One standard data set included in the R
Distribution is the 
sunspot data.  As an example of RSEIS we can read this time series in and plot it using the
same code introduced above.
<<fig=TRUE, echo=TRUE, results=hide>>=
data(sunspots)

AA = attributes(sunspots)
starttime=list(yr=AA$tsp[1], jd=1,mo=1,dom=1,hr=0,mi=0,sec=0)
ES = prep1wig(wig=sunspots, dt=1/12, sta="STA", comp="CMP", units="UNITS", starttime=starttime    )

EH=prepSEIS(ES)

STDLAB = c("DONE",  "zoom in", "zoom out", "refresh", "restore",
 "XTR", "SPEC", "SGRAM" ,"WLET", "FILT",  "Pinfo")

xx =  swig( EH, STDLAB = STDLAB,  SHOWONLY=TRUE)

@ 


<<>>=
a = list(y=EH$JSTR[[1]], dt=EH$dt[1])
 Mspec = mtapspec(a$y, a$dt, klen =1024 , MTP = list(kind = 1,
        nwin = 5, npi = 3, inorm = 0))
    f = Mspec$freq
    amp = Mspec$spec[1:length(f)]
    ma = amp
displ = ma
f1 = 0.01
f2 = 1/(2*EH$dt[1])

    flag = f >= f1 & f <= f2
plxy = "xy"

 plot(range(f[flag]),range(displ[flag]),type='n',log=plxy,axes=FALSE, xlab="Hz", ylab="Spec")
      lines(f[flag], displ[flag], col=1, lty=1)       
      axis(2, las=2)
      axis(1)
      box()
  ##     L = locator()
 ## rDUMPLOC(L)
  
L=list()
L$x=c(0.0939105803154482,0.183351679178275,0.350333785192083)
L$y=c(31166.8951116052,7536.36156151748,2370.29538151056)

abline(v=L$x, lty=2, col=grey(0.8) )
text(L$x, rep(max(range(displ[flag])), length(L$x)),  labels=round((1/L$x)), xpd=TRUE, srt=45, adj=c(0,0) )



@ 


\subsection{Example: Climate Change}

As a final example showing how RSEIS might be used for 
arbitrary time series, unrelated to 
seismic data, consider the famous 
Delta-O18 time series.  By windowing the 
time sereis and looking at the 
spectrum one can immediately see the 
Milankovitch cycles at (approximately) 100K, 41K and 20K periods.

<<fig=TRUE, echo=TRUE, results=hide>>=
data(OH)
xx =  swig( OH, sel=which(OH$COMPS == "V"), STDLAB = STDLAB,  SHOWONLY=TRUE)

@ 

<<fig=TRUE, echo=TRUE, results=hide>>=
a = list(y=OH$JSTR[[1]], dt=OH$dt[1])
 Mspec = mtapspec(a$y, a$dt, klen =1024 , MTP = list(kind = 1,
        nwin = 5, npi = 3, inorm = 0))
    f = Mspec$freq
    amp = Mspec$spec[1:length(f)]
    ma = amp
displ = ma
f1 = 0.01
f2 = 1/(2*EH$dt[1])

    flag = f >= f1 & f <= f2
plxy = "xy"

 plot(range(f[flag]),range(displ[flag]),type='n',log=plxy,axes=FALSE, xlab="Hz", ylab="Spec")
      lines(f[flag], displ[flag], col=1, lty=1)       
      axis(2, las=2)
      axis(1)
      box()
      
##   L = locator()
##   rDUMPLOC(L)

u = par("usr")
L=list()
L$x=c(0.242745864538716,0.423063797271721,0.447439169221329,0.529320129815409,0.100457805181183)
L$y=c(37.4392793655756,19.0231348719557,15.6564640841027,15.0862607475168,40.6986171075992)

abline(v=L$x, lty=2, col=grey(0.8) )
text(L$x, rep(max(range(displ[flag])), length(L$x)),  labels=round(10000*(1/L$x)), xpd=TRUE, srt=45, adj=c(0,0) )




@ 



To illustrate the effects of comparing numerous filters to 
a specific volcanic explosions event,


<<fig=TRUE, echo=TRUE, results=hide>>=
 data(KH)
     dt = KH$dt[1]


     y =  KH$JSTR[[1]]
     y = y[1:50000]
y = y-mean(y)
     x =  seq(from=0, by=dt, length=length(y))




     fl=rep(1/100, 5)
     fh=1/c(4,3,2,1, .5)

     FILT.spread(x, y, dt, fl = fl, fh = fh, sfact = 1, WIN = NULL, PLOT = TRUE, TIT = NULL, TAPER = 0.05, POSTTAPER = 0.1)


@ 




\end{document}

\documentclass{article}
\usepackage{amsmath} %Never write a paper without using amsmath for its many new commands
\usepackage{amssymb} %Some extra symbols
\usepackage{makeidx} %If you want to generate an index, automatically
\usepackage{graphicx} %If you want to include postscript graphics
%%%  \usepackage{mystyle} 
%Create your own file, mystyle.sty where you put all your own \newcommand statements
%%%
%%%
\usepackage{amscd}

\usepackage{Sweave}


%%\VignetteIndexEntry{Example hodograms}

%%% \usepackage{Sweave}

\begin{document}

%%%\renewcommand\floatpagefraction{.9}
%%%\renewcommand\topfraction{.9}
%%%\renewcommand\bottomfraction{.9}
%%%\renewcommand\textfraction{.1}
%%%\setcounter{totalnumber}{50}
%%%\setcounter{topnumber}{50}
%%%\setcounter{bottomnumber}{50}

\setkeys{Gin}{width=0.9\textwidth}



\numberwithin{equation}{section}

%%%   \SweaveOpts{prefix.string=hodo}
\SweaveOpts{prefix=TRUE,prefix.string=hodo,include=TRUE}


\author{Jonathan M. Lees\\
University of North Carolina, Chapel Hill\\
Department of Geological Sciences\\
CB \#3315, Mitchell Hall\\
Chapel Hill, NC  27599-3315\\
email: jonathan.lees@unc.edu\\
ph: (919) 962-0695
}
%%  \address{University of North Carolina, Chapel Hill}
%% \contact{Jonathan M. Lees}
%% \contactaddress{Department of Geological Sciences, CB #3315, Mitchell Hall, Chapel Hill, NC  27599-3315}
%% \contactemail{jonathan.lees@unc.edu}
%% \contactphone{(919) 962-0695}
\title{Seismic Hodograms in R}
\date{March, 2008}

\maketitle


\begin{abstract}
Plot hodograms (particle motion) for 3-component seismic data.
\end{abstract}

\section{Example}

Start out by calling the RSEIS library,

<<fig=FALSE, echo=TRUE, results=hide>>=
library(RSEIS)
@ 

Then load some data and plot.  This data is from the Coso Geothermal field in Coso Califormia.
The data is sampled at 250 sampled/sec and there are numerous stations recorded
on three components.   Some stations are too noise for particle motion analysis.

<<fig=FALSE, echo=TRUE, results=hide>>=
data(GH)

swig(GH, SHOWONLY=TRUE)

@ 

In this case the GH structure holds the 
phase arrival information as well as the station locations and event location.

<<echo=TRUE>>=
print(GH$pickfile$STAS$name)
@ 

We will choose one station and do the hodogram analysis there, but 
our analysis could easily be put in a loop to cover all the stations.

<<echo=TRUE>>=

thesta = "CE1"
iwv  = which(GH$STNS==thesta & GH$COMPS=="V")
iwn  = which(GH$STNS==thesta & GH$COMPS=="N")
iwe  = which(GH$STNS==thesta & GH$COMPS=="E")


data = cbind(GH$JSTR[[iwv]], GH$JSTR[[iwn]], GH$JSTR[[iwe]])


@ 

Next we get the station back azimuth to the seismic event, 
which has been located previously.  The information on
the location of the seismic event is stored also in the pickfile.


<<echo=TRUE>>=
ipphase = which(GH$pickfile$STAS$name==thesta & GH$pickfile$STAS$phase=="P" )
isphase = which(GH$pickfile$STAS$name==thesta & GH$pickfile$STAS$phase=="S" )


lat=GH$pickfile$STAS$lat[ipphase]
lon = GH$pickfile$STAS$lon[ipphase]
DAZ = rdistaz(lat, lon,   GH$pickfile$LOC$lat,GH$pickfile$LOC$lon )
 rbaz = grotseis(DAZ$baz, flip=FALSE)

@ 

To illustrate the approach we start by plotting 
a map view of the stations and the earthquake source,

<<fig=TRUE>>=

plot( c(GH$pickfile$STAS$lon, GH$pickfile$LOC$lon) , c(GH$pickfile$STAS$lat, GH$pickfile$LOC$lat), type='n', xlab="LON", ylab="LAT")
points(GH$pickfile$STAS$lon, GH$pickfile$STAS$lat, pch=6)
points(GH$pickfile$LOC$lon, GH$pickfile$LOC$lat, pch=8)
text(GH$pickfile$STAS$lon, GH$pickfile$STAS$lat,  GH$pickfile$STAS$name, pos=3)

##  plot( c(lon, GH$pickfile$LOC$lon) , c(GH$pickfile$STAS$lat, GH$pickfile$LOC$lat))
##  text(lon, lat, labels="station")


@ 

These can be plotted in km rather than LAT-LON by either projection
or byu simply using the distances 
to the stations and azimuths to get the approximate flat orientation.
We show the orientation of the horizontal components after the seismogram gets rotated by
the designated angle.  The red arrow is the radial component and the blue
is the transverse.

<<fig=TRUE>>=

x = DAZ$dist*sin(DAZ$baz*pi/180)
y = DAZ$dist*cos(DAZ$baz*pi/180)

plot(c(0,1.3*x), c(0,1.3*y), type='n', asp=1, xlab="E-W, km", ylab="N-S, km")
points(c(0,x), c(0,y), pch=c(3,6))
text(x,y, labels="station", pos=1)
text(x,y, labels=GH$pickfile$STAS$name[ipphase], pos=2)


text(0,0, labels="source", pos=3)

vecs  = rbind(c(0,0,1), c(0,1,0))
bvec  = vecs %*%  rbaz

bvec = .1*DAZ$dist*bvec
arrows(x,y, x+bvec[,2], y+bvec[,3], col=c("red", "blue"))

 

@ 


We first plot the data in its original Vertical-North-East orientation,

<<fig=TRUE>>=

## data = cbind(GH$JSTR[[iwv]], GH$JSTR[[iwn]], GH$JSTR[[iwe]])

  vnelabs=c("Vertical", "North", "East")
  
rotlabs=c("Vertical", "Radial(away)", "Transvers(right)")

 xt=seq(from=0, by=GH$dt[iwv], length=length(GH$JSTR[[iwv]]))

 PLOT.MATN(data, tim=xt, dt=GH$dt[iwv], notes=vnelabs)

@ 


And then we rotate the seismograms so that they are oriented 
Vertical-Radial-Transverse, is is often done in seismic analysis:


<<fig=TRUE>>=

## data = cbind(GH$JSTR[[iwv]], GH$JSTR[[iwn]], GH$JSTR[[iwe]])
btemp  = data  %*%  rbaz

 PLOT.MATN(btemp, tim=xt, dt=GH$dt[iwv], notes=rotlabs)

@ 

Next we extract information from the seismic structure that
tells us when the P and S-arrival were estimated.  This information\
is stored in the pickfile structure,
but we want to know how many seconds paste the start of the trace the
arrivals came in, so we can window that portion of the trace
for hodogram analysis.

<<fig=TRUE>>=


i1 = match(GH$STNS[iwv],  GH$pickfile$STAS$name)


reft = list(jd=GH$info$jd[iwv], hr=GH$info$hr[iwv], mi=GH$info$mi[iwv], sec=GH$info$sec[iwv] )


ptim = list(jd=GH$pickfile$LOC$jd, hr=GH$pickfile$LOC$hr, mi=GH$pickfile$LOC$mi, sec=GH$pickfile$STAS$sec[ipphase] )
stim = list(jd=GH$pickfile$LOC$jd, hr=GH$pickfile$LOC$hr, mi=GH$pickfile$LOC$mi, sec=GH$pickfile$STAS$sec[isphase] )

t1 = secdifL( reft, ptim)
t2 = secdifL( reft, stim)

 PLOT.MATN(btemp, WIN=c(5,8) , tim=xt, dt=GH$dt[iwv], notes=rotlabs)
abline(v=t1, col='red', lty=2)
abline(v=t2, col='blue', lty=2)

mtext(side=3, at=t1, line=.1, text="Pwave", col='red')
mtext(side=3, at=t2, line=.1, text="Swave", col='blue')

pwin = c(t1-.02, t1+.09)
swin = c(t2-.01, t2+.1)

abline(v=pwin, col='red', lty=2)
abline(v=swin, col='blue', lty=2)



@ 

So we now extract that portion and apply the hodogram program
on the P-wave arrival

<<fig=TRUE>>=
rbow=rainbow(140)[1:100]

atemp = btemp[xt>pwin[1]&xt<pwin[2]  ,]
##  PLOT.MATN(atemp,  tim=xt[xt>pwin[1]&xt<pwin[2]], dt=GH$dt[iwv], notes=rotlabs)

 hodogram(atemp, dt=GH$dt[iwv]  ,labs=rotlabs,  STAMP=thesta,  COL=rbow )

@ 

and on the S-wave arrival

<<fig=TRUE>>=

atemp = btemp[xt>swin[1]&xt<swin[2]  ,]
###  PLOT.MATN(atemp,  tim=xt[xt>swin[1]&xt<swin[2]], dt=GH$dt[iwv], notes=rotlabs)

 hodogram(atemp, dt=GH$dt[iwv]  ,labs=rotlabs,  STAMP=thesta,  COL=rbow )

@ 

Clearly,  a loop
can be programed so that all the stations are examined for the 
particle motion and specific patterns will be revealed.

For example, we may wish to differentiate 
between direct arrival of body waves
and later arrivals of surface waves.
The Raleigh wave has retrograde motion int he vertical-radial 
components, so we expect to see the first motions moving 
opposite the direction of wave propagation (i.e. towards the source)
as the motion is decomposed.


Hodograms  can be used to estimate 
the arrival of a ``split shear wave'' often used to 
detect anisotropy in the geologic structures in the subsurface.
In some cases anisotropy indicates crack orientation and in the mantle 
it may refer to fluid flow as olivene crystals align
along the direction of flow.




\end{document}
